/*
 * This program is distributed under the terms of the GPL v2.0 or later
 * Download the GNU Public License (GPL) from www.gnu.org
 *  Support the Free Software Foundation.
*/

#pragma pack(2)
#include <Pilot.h>
#include "docrec.h"
#include "progress.h"
#include "tag.h"
#include "line.h"

#define alertInfo  3801

// static DmOpenRef countDbR;
static LocalID countID;

static int *g_countList;


void freeLCount(void)
{
   if (g_countList != NULL) {
      MemPtrFree(g_countList);
      g_countList = NULL;
   }
}

static void MakeCountList(void)
{
   UInt page;
   freeLCount();
   page = DOC_Values.count;
   g_countList = MemPtrNew(page * sizeof(*g_countList));
   if (g_countList == 0) {
      FrmCustomAlert(alertInfo, "alloc listItem error", " ", " ");
      return;
   }
   while (page > 0) {
      page--;
      g_countList[page] = -1;
   }
}



static UInt searchPos(DmOpenRef DbR, UInt page, UInt line)
{
   CharPtr p;
   int i;
   int c;
   loadrec(DbR, page);
   p = DOC_Text.text;
   i = 0;
   c = 0;
   while (i < DOC_Text.len && c < line) {
      if (*p == '\n') {
	 c++;
      }
      p++;
      i++;
   }
   return i;
}

static int getCount(DmOpenRef DbR, UInt page)
{
   CharPtr p;
   int i;
   int c;
   loadrec(DbR, page);
   p = DOC_Text.text;
   i = 0;
   c = 0;
   while (i < DOC_Text.len) {
      if (*p == '\n') {
	 c++;
      }
      p++;
      i++;
   }
   return c;
}

void searchLine(LocalID dbID, DmOpenRef DbR, int line)
{
   int count;
   int precount;
   int page;
   FormPtr frm;
   Word formID;
   formID = FrmGetActiveFormID();
   frm = ProgStart(formID_wait, "wait:line");

   if (countID != dbID) {
      /* ng countDBr != dbR */
#if TEST
      FrmCustomAlert(alertInfo, "MakeCountList", " ", " ");
#endif
      MakeCountList();
      countID = dbID;
   }
   precount = 0;
   count = 1;
   page = 1;
   while (count <= line && page <= DOC_Values.count) {
      precount = count;
      if (g_countList[page - 1] == -1) {
	 g_countList[page - 1] = getCount(DbR, page);
      }
      count = count + g_countList[page - 1];
      page++;
   }
   goInfo.page = page - 1;
   goInfo.insPos = searchPos(DbR, page - 1, line - precount);
   ProgStop(formID);
}
